
package de.ivu.elect.business.gruppeimgebiet.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet;

// abgeleitete Klasse mit "@javax.ejb.Stateless" annotieren!
public abstract class AbstractGruppeImGebietEdit {

  @Inject
  protected GruppeImGebietDAO dao;

  @Inject
  protected GruppeImGebietExtendedDAO extendedDao;

  public void delete(GruppeImGebiet entity) {
    dao.remove(getAttachedEntity(entity));
  }

  public void save(GruppeImGebiet entity) {
    validate(entity);

    flushToSave();
  }

  protected void validate(GruppeImGebiet entity) {
    // Do nothing by default.
  }

  protected void flushToSave() {
    if(usesMixedTransactionalContexts()) {
        extendedDao.flushNewTransaction();
    } else {
        extendedDao.flush();
    }
  }

  // ELECT-945
  protected boolean usesMixedTransactionalContexts() {
    return false;
  }

  protected GruppeImGebiet getAttachedEntity(GruppeImGebiet entity) {
    return dao.findByPrimaryKey(entity.getPk());
  }

  // Cf. ELECT-3187 (Änderungen an Entität werden nicht gespeichert)
  protected GruppeImGebiet getAttachedAndRefreshedEntity(GruppeImGebiet entity) {
    return dao.refresh(entity);
  }
}
